﻿using Harmony;
using System.Reflection;
using UnityEngine;

public class AnthillKill : Mod
{
    HarmonyInstance instance;
    public void Start()
    {
        instance = HarmonyInstance.Create("fr.tekgamer.anthillkill");
        instance.PatchAll(Assembly.GetExecutingAssembly());
        Debug.Log("Mod AnthillKill has been loaded!");
    }

    public void OnModUnload()
    {
        instance.UnpatchAll();
        Debug.Log("Mod AnthillKill has been unloaded!");
    }
}

[HarmonyPatch(typeof(WeaponController))]
[HarmonyPatch("HitObject")]
internal class Patch_WeaponController_HitObject
{
    public static bool Prefix(WeaponController __instance, CJObject obj, Vector3 hit_pos, Vector3 hit_dir)
    {
		if (obj.name.Equals("anthill"))
		{
			AnthillHealth anthillHealth = obj.gameObject.GetComponent<AnthillHealth>();
			if (!anthillHealth)
			{
				anthillHealth = obj.gameObject.AddComponent<AnthillHealth>().Init(50f);
			}
			float num = 10f;
			anthillHealth.health -= num;
			if (anthillHealth.health <= 0f)
			{
				Object.Destroy(obj.gameObject);
			}
			return false;
		}
		return true;
	}
}

public class AnthillHealth : MonoBehaviour
{
	public AnthillHealth Init(float x = 50f)
	{
		maxHealth = x;
		health = x;
		return this;
	}

	public float health;

	public float maxHealth;
}